(function( $ ) {
	'use strict';

	/**
	 * All of the code for your Dashboard-specific JavaScript source
	 * should reside in this file.
	 *
	 * Note that this assume you're going to use jQuery, so it prepares
	 * the $ function reference to be used within the scope of this
	 * function.
	 *
	 * From here, you're able to define handlers for when the DOM is
	 * ready:
	 *
	 * $(function() {
	 *
	 * });
	 *
	 * Or when the window is loaded:
	 *
	 * $( window ).load(function() {
	 *
	 * });
	 *
	 * ...and so on.
	 *
	 * Remember that ideally, we should not attach any more than a single DOM-ready or window-load handler
	 * for any particular page. Though other scripts in WordPress core, other plugins, and other themes may
	 * be doing this, we should try to minimize doing that in our own work.
	 */     
})( jQuery );

//Save post order
function save_order(){ 
	var allVals = [];
	var allIDs = [];
	//get each input value
	jQuery(".wp-list-table .postorder").each(function(){
		allVals.push(jQuery(this).val()); 
		allIDs.push(jQuery(this).attr('id')); 
	});
	//Call ajax method to post values
	jQuery.ajax({
		method: "POST",
		url: "admin-ajax.php?funct=fn_saveorder",
		data: { erp_post:1, id: allIDs, val: allVals },
		success: function(){
			var href = jQuery('.column-order a').first().attr('href'); 
			window.location = href;
		}
	});
}
 
//Registration form fields box toggle

function show_regform_fields()
{	
	jQuery('#reg_form_fields').slideDown(1000);

	
	
}
function publish_post(){
	jQuery( "#publish" ).click();
}

//Hide Registration form fields section
function fn_cancel_regform_edit(type,postid)
{
	if(type=='add'){
		jQuery('#reg_form_fields').slideUp(1000);	
	}
	else
	{
		href = "post.php?post="+postid+"&action=edit";
		window.location = href;	 
	}
}

//On new category add refresh page to refresh category table
function fn_ajax_complete()
{
	jQuery( document ).ajaxComplete(function( event, request, settings ) {  
	  var data = settings.data;
	  var arr = data.split('&');
	  var arr_action = arr[0].split('='); 
	  if(arr_action[1]=='add-tag'){ 
		 window.location.replace("edit-tags.php?taxonomy=erp-event-category&post_type=erp_event");
	  } 
	});
}
 
function initialize(divid) 
{  
	//get address
	var street = jQuery('.txt_street').val();
	var city = jQuery('.txt_city').val();
	var country = jQuery('.txt_country').val();
	
	var address = '';
	if(street!=''){
		var address = street;
	}
	
	if(address!='' && city!=''){
		var address = address+','+city;
	}
	else if(address=='' && city!='')
	{
		var address = city;
	}
	
	if(address!='' && country!=''){
		var address = address+','+country;
	}
	else if(address=='' && country!='')
	{
		var address = country;
	}  
	if(address!=''){
		jQuery.getJSON('https://maps.googleapis.com/maps/api/geocode/json?address=' + address + '&sensor=false', null, function (data) {
			var p = data.results[0].geometry.location
			var lat  = p.lat
			var lng = p.lng;         
			loadmap(lat,lng,address,divid);       
		});
	} 
}

function loadmap(lat,lng,address,divid)
{  
	jQuery('#map-canvas').css('height','400px');
	var geocoder = new google.maps.Geocoder();
	
	var latlng = new google.maps.LatLng(lat,lng);
	 
	var mapOptions = {
		zoom: 15,
		mapTypeId: google.maps.MapTypeId.ROADMAP,
		center: latlng, 
		scrollwheel: false
	};
	map = new google.maps.Map(document.getElementById(divid),mapOptions);
	
	
	if (geocoder) {
		geocoder.geocode( { 'address': address}, function(results, status) {
			if (status == google.maps.GeocoderStatus.OK) 
			{
				if (status != google.maps.GeocoderStatus.ZERO_RESULTS) 
				{ 
					map.setCenter(latlng);
					var infowindow = new google.maps.InfoWindow(
					{
						content: address,
						map: map,
						position: latlng
					});
					
					var marker = new google.maps.Marker({
						position: latlng,
						map: map, 
						title:address
					});  
				} 
				else 
				{
					alert("No results found");
				}
			}
		});
	} 
}

//Save order of registration form fields order
function save_order_regform_fields(postid,nonce,order){	
	var allVals = [];
	var allIDs = [];
	var order = order;
	//get each input value
	jQuery(".wp-list-table .postorder").each(function(){
		allVals.push(jQuery(this).val()); 
		allIDs.push(jQuery(this).attr('id')); 
	});
	//Call ajax method to post values
	jQuery.ajax({
		method: "POST",
		url: "admin-ajax.php?funct=save_regFormFields_order",
		data: { erp_regform_post:1, postid: postid, id: allIDs, val: allVals,nonce:nonce },
		success: function(){
			var href = 'post.php?post='+postid+'&action=edit&rforderby=order&rforder='+order; 
			window.location = href;
		}
	});
}

//On click of head checkbox, check/uncheck sub checkbox
function chkAll(main_chk_class,sub_chk_class){
	if (jQuery('.'+main_chk_class).prop('checked')) {
        jQuery('.'+sub_chk_class).prop('checked', true);
    } else {
        jQuery('.'+sub_chk_class).prop('checked', false);
    }
}

function subchkAll(name,main_chk_class,item){
	if (jQuery('[name="'+name+'"]:checked').length == jQuery('[name="'+name+'"]').length || !item.checked){
		jQuery('.'+main_chk_class).prop('checked', item.checked);
	}
}

//On click of edit registration form field
function fn_edit_regform(id,postid)
{ 
	href = "post.php?post="+postid+"&action=edit&customid="+id+"#regform-fields-meta-boxes";
	window.location = href;	 
}

//Delete registration form fields
function regform_delete(pid,nonce)
{
	var selected = [];
	jQuery.each(jQuery("input[name='regform_fields[]']:checked"), function(){            
		selected.push(jQuery(this).val());
	});
	var len = selected.length;
	if(len > 0){
		
		var confirm_msg = confirm("Are you sure you want to delete?");
		if(confirm_msg){
			//Call ajax method to post values
			jQuery.ajax({
				method: "POST",
				url: "admin-ajax.php?funct=deleteRegFormFields",
				data: { delRegFormFields:1, pid: pid, val: selected,nonce:nonce },
				success: function(){
					var href = 'post.php?post='+pid+'&action=edit'; 
					window.location = href;
					//location.reload();
				}
			});
		}
		else
		{
			return false;
		}
	}
	else
	{
		alert("Please select record");
		return false;
	} 
}


