<?php
if ( ! defined( 'ABSPATH' ) ) exit;
class Event_Registration_Pro_Metabox {
	   
	/**
	 * Meta box display callback.
	 *
	 * @param WP_Post $post Current post object.
	 */ 
	
	////////////////////////////////////////Dashboard////////////////////////////////////////////
	public function add_dashboard_page()
	{
		$plugin_dashboard = new Event_Registration_Pro_Dashboard(); 
		$menu_slug = 'edit.php?post_type=erp_event';
		add_submenu_page( $menu_slug, __( 'Dashboard','event-registration-pro' ), __( 'Dashboard', 'event-registration-pro' ), 'manage_options', 'event-dashboard', array(&$plugin_dashboard, 'event_dashboard')); 
	}   
	/////////////////////////////////////////////////////////////////////////////////////////////
	
	////////////////////////////////////////Configuration////////////////////////////////////////////
	public function add_configuration_page()
	{
		$plugin_configuration = new Event_Registration_Pro_Configuration();  
		$menu_slug = 'edit.php?post_type=erp_event';  
	 	add_submenu_page( $menu_slug, __( 'Main Settings', 'event-registration-pro' ), __( 'Main Settings', 'event-registration-pro' ), 'manage_options', 'event-configuration', array(&$plugin_configuration, 'event_configuration')); 
	}    
	/////////////////////////////////////////////////////////////////////////////////////////////   
	
	////////////////////////////////////////Event Manager//////////////////////////////////////// 
	//1 ........................Event Details Tab...........................................
	public function add_erp_event_details_metabox()
	{    
		$prefix = 'erp_event_';
		global $meta_box_details;
		 
		$meta_box_details = array(
			'id' => 'event-details-meta-boxes',
			'title' => __( 'Event Details', 'event-registration-pro' ),
			'page' => 'erp_event',  
			'context' => 'normal',
			'priority' => 'high',
			'fields' => array(
				
				array( 
					'name' 	=> __( 'Event Date', 'event-registration-pro' ), 
					'desc' 	=> '',
					'id' 	=> $prefix . 'date',
					'type' 	=> 'text',
					'std' 	=> '',
					'taxonomy' => '',
					'required' => 1,
					'class' => 'erp_event_date',
					'values' => '',
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => '',
					'is_wp_editor' => 0
				),
				array(
					'name' 	=> __( 'Time', 'event-registration-pro' ),
					'desc' 	=> '',
					'id' 	=> $prefix . 'time',
					'type' 	=> 'text',
					'std' 	=> '',
					'taxonomy' => '',
					'required' => 1,
					'class' => 'erp_event_time',
					'values' => '',
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => '',
					'is_wp_editor' => 0
				),
				array(
					'name' 	=> __( 'Enddate', 'event-registration-pro' ),
					'desc' 	=> '',
					'id' 	=> $prefix . 'enddate',
					'type' 	=> 'text',
					'std' 	=> '',
					'taxonomy' => '',
					'required' => 1,
					'class' => 'erp_event_date',
					'values' => '' ,
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => '',
					'is_wp_editor' => 0
				),
				array(
					'name' 	=> __( 'Endtime', 'event-registration-pro' ),
					'desc'	=> '',
					'id' 	=> $prefix . 'endtime',
					'type' 	=> 'text',
					'std'	=> '',
					'taxonomy' => '',
					'required' => 1,
					'class' => 'erp_event_time',
					'values' => '',
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => 'left',
					'is_wp_editor' => 0
				), 
				array(
					'name' 	=> __( 'Does this event have a physical location?', 'event-registration-pro' ),
					'desc'	=> '',
					'id' 	=> $prefix . 'does_this_event_have_a_physical_location',
					'type' 	=> 'radio',
					'std'	=> '',
					'taxonomy' => '',
					'required' => 0,
					'class' => '',
					'values' => array('No','Yes'),
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => '',
					'is_wp_editor' => 0
				), 
				array(
					'name' 	=> __( 'Location', 'event-registration-pro' ),
					'desc'	=> '',
					'id' 	=> $prefix . 'location',
					'type' 	=> 'select',
					'std'	=> '', 
					'taxonomy' => '',
					'required' => 0,
					'class' => '',
					'values' => '',
					'post_type' => 'erp_locations',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => 'show_location_yes_no',
					'is_wp_editor' => 0
				),
				array(
					'name' 	=>  __( 'Category', 'event-registration-pro' ),
					'desc'	=> '',
					'id' 	=> $prefix . 'category',
					'type' 	=> 'select',
					'std'	=> '',
					'taxonomy' => 'erp-event-category',
					'required' => 1,
					'class' => '', 
					'values' => '',
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => '',
					'is_wp_editor' => 0
				),
				array(
					'name' 	=>  __( 'Event organizer', 'event-registration-pro' ),
					'desc'	=> '',
					'id' 	=> $prefix . 'organizers',
					'type' 	=> 'select',
					'std'	=> '',
					'taxonomy' => '',
					'required' => 0,
					'class' => '', 
					'values' => '',
					'post_type' => 'erp_organizers',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => '',
					'is_wp_editor' => 0 
				),
				array(
					'name' 	=> __( 'Feature this event', 'event-registration-pro' ),
					'desc'	=> '',
					'id' 	=> $prefix . 'feature_this_event',
					'type' 	=> 'radio',
					'std'	=> '',
					'taxonomy' => '',
					'required' => 0,
					'class' => '', 
					'values' => array('No','Yes'),
					'post_type' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => '',
					'is_wp_editor' => 0
				),
				array(
					'name' 	=> __( 'Location Map', 'event-registration-pro' ),
					'desc'	=> '',
					'id' 	=> $prefix . 'location_map',
					'type' 	=> 'radio',
					'std'	=> '',
					'taxonomy' => '',
					'required' => 0,
					'class' => '', 
					'values' => array('No','Yes'),
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => '',
					'is_wp_editor' => 0
				),
				array(
					'name' 	=> __( 'Show Event CountDown Timer', 'event-registration-pro' ),
					'desc'	=> '',
					'id' 	=> $prefix . 'countdown_timer',
					'type' 	=> 'radio',
					'std'	=> '',
					'taxonomy' => '',
					'required' => 0,
					'class' => '',
					'values' => array('No','Yes'),
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => '',
					'is_wp_editor' => 0
				),
				array(
					'name' 	=> __( 'Max Attendance', 'event-registration-pro' ),
					'desc'	=> 'Leave 0 or empty for unlimited',
					'id' 	=> $prefix . 'max_attendance',
					'type' 	=> 'text',
					'std'	=> '',
					'taxonomy' => '',
					'required' => 0,
					'class' => '',
					'values' => '',
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => '',
					'is_wp_editor' => 0
				),
				array(
					'name' 	=> __( 'Event Banner', 'event-registration-pro' ),
					'desc'	=> '',
					'id' 	=> $prefix . 'banner',
					'type' 	=> 'image',
					'std'	=> '',
					'taxonomy' => '',
					'required' => 0,
					'class' => '',
					'values' => '',
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => '',
					'is_wp_editor' => 0 
				)               
			)   
		);
		add_meta_box($meta_box_details['id'], $meta_box_details['title'], array(&$this, 'show_erp_event_details_metabox'), 'erp_event', $meta_box_details['context'], $meta_box_details['priority']);  
 	}  
	
	//Function to show Event Details Metaboxes 
	public function show_erp_event_details_metabox()  
	{   
		global $meta_box_details;  
		$plugin_show_metabox = new Event_Registration_Pro_Show_Metabox();
        $plugin_show_metabox->fn_show_fields($meta_box_details,'event_details'); 
	} 
	
	//2 .........................Access Tab.................................................
	public function add_erp_event_access_metabox()
	{ 	
		$prefix = 'erp_event_';
		global $meta_box_access;
		$meta_box_access = array(
			'id' => 'event-access-meta-boxes',
			'title' => __( 'Wordpress Access Levels', 'event-registration-pro' ),
			'page' => 'erp_event',  
			'context' => 'normal',
			'priority' => 'low',
			'fields' => array(
				array(
					'name' 	=> __( 'Registration Access', 'event-registration-pro' ), 
					'desc'	=> '',
					'id' 	=> $prefix . 'registration_access',
					'type' 	=> 'select',
					'std' 	=> '',
					'taxonomy' => '',
					'required' => 0,
					'class' => '',
					'values' => array('Public','Administrator','Author','Editor','Subscriber','Contributor'),
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => '',
					'is_wp_editor' => 0
				), 
				array(
					'name' 	=> __( 'View Access', 'event-registration-pro' ), 
					'desc'	=> '',
					'id' 	=> $prefix . 'view_access',
					'type' 	=> 'select',
					'std' 	=> '',
					'taxonomy' => '',
					'required' => 0,
					'class' => '',					
					'values' => array('Public','Administrator','Author','Editor','Subscriber','Contributor'),
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => '',
					'is_wp_editor' => 0 
				)            
			)   
		);
		add_meta_box($meta_box_access['id'], $meta_box_access['title'], array(&$this, 'show_erp_event_access_metabox'), 'erp_event', $meta_box_access['context'], $meta_box_access['priority']); 
	}
	 
	//Function to show Event Access Metaboxes 
	public function show_erp_event_access_metabox()  
	{   
		global $meta_box_access;   
		$plugin_show_metabox = new Event_Registration_Pro_Show_Metabox();
        $plugin_show_metabox->fn_show_fields($meta_box_access,'event_access'); 
	} 
	
	//3 .........................Registration Tab.................................................
	public function add_erp_event_registration_metabox()
	{ 	
		$prefix = 'erp_event_';
		global $meta_box_registration;
		$meta_box_registration = array(
			'id' => 'event-registration-meta-boxes',
			'title' => __( 'Registration', 'event-registration-pro' ),
			'page' => 'erp_event',  
			'context' => 'normal',
			'priority' => 'low',
			'fields' => array(
				array(
					'name' 	=> __( 'Enable registration', 'event-registration-pro' ), 
					'desc'	=> '',
					'id' 	=> $prefix . 'enable_registration',
					'type' 	=> 'radio',
					'std' 	=> '',
					'taxonomy' => '',
					'required' => 0,
					'class' => 'enable_registration',
					'values' => array('No','Yes'),
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => '',
					'is_wp_editor' => 0
				), 
				array(
					'name' 	=> __( 'Show Attendees List', 'event-registration-pro' ), 
					'desc'	=> '',
					'id' 	=> $prefix . 'show_attendees_list',
					'type' 	=> 'radio',
					'std' 	=> '',
					'taxonomy' => '',
					'required' => 0,
					'class' => '',
					'values' => array('No','Yes'),
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => 'enable_registration_yes_no',
					'is_wp_editor' => 0 
				), 
				array(
					'name' 	=> __( 'Allow group registration', 'event-registration-pro' ), 
					'desc'	=> '',
					'id' 	=> $prefix . 'allow_group_registration',
					'type' 	=> 'radio',
					'std' 	=> '',
					'taxonomy' => '',
					'required' => 0,
					'class' => '',
					'values' => array('No','Yes'),
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => 'enable_registration_yes_no',
					'is_wp_editor' => 0
				),
				array(
					'name' 	=> __( 'Force group registration', 'event-registration-pro' ), 
					'desc'	=> '',
					'id' 	=> $prefix . 'force_group_registration',
					'type' 	=> 'radio',
					'std' 	=> '',
					'taxonomy' => '',
					'required' => 0,
					'class' => '',
					'values' => array('No','Yes'),
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => 'enable_registration_yes_no',
					'is_wp_editor' => 0 
				),
				array(
					'name' 	=> __( 'Registration form', 'event-registration-pro' ), 
					'desc'	=> '',
					'id' 	=> $prefix . 'select_registration_form',
					'type' 	=> 'select',
					'std' 	=> '',
					'taxonomy' => '',
					'required' => 0,
					'class' => '',
					'values' => '',
					'post_type' => 'erp_regforms',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => 'enable_registration_yes_no',
					'is_wp_editor' => 0 
				),
				array(
					'name' 	=> __( 'Event Registration starts date', 'event-registration-pro' ), 
					'desc'	=> '',
					'id' 	=> $prefix . 'registration_starts_date',
					'type' 	=> 'text',
					'std' 	=> '',
					'taxonomy' => '',
					'required' => 1,
					'class' => 'erp_event_date ',
					'values' => '',
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => 'enable_registration_yes_no',
					'is_wp_editor' => 0
				),
				array(
					'name' 	=> __( 'Event Registration starts time', 'event-registration-pro' ), 
					'desc'	=> '',
					'id' 	=> $prefix . 'registration_starts_time',
					'type' 	=> 'text',
					'std' 	=> '',
					'taxonomy' => '',
					'required' => 1,
					'class' => 'erp_event_time ',
					'values' => '',
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => 'enable_registration_yes_no',
					'is_wp_editor' => 0 
				),
				array(
					'name' 	=> __( 'Event Registration ends date', 'event-registration-pro' ), 
					'desc'	=> '',
					'id' 	=> $prefix . 'registration_ends_date',
					'type' 	=> 'text',
					'std' 	=> '',
					'taxonomy' => '',
					'required' => 1,
					'class' => 'erp_event_date ',
					'values' => '',
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => 'enable_registration_yes_no',
					'is_wp_editor' => 0 
				),
				array(
					'name' 	=> __( 'Event Registration ends time', 'event-registration-pro' ), 
					'desc'	=> '',
					'id' 	=> $prefix . 'registration_ends_time',
					'type' 	=> 'text',
					'std' 	=> '',
					'taxonomy' => '',
					'required' => 1,
					'class' => 'erp_event_time ',
					'values' => '',
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => 'enable_registration_yes_no',
					'is_wp_editor' => 0 
				),
				array(
					'name' 	=> __( 'Create Wordpress User Account When Registering', 'event-registration-pro' ), 
					'desc'	=> '',
					'id' 	=> $prefix . 'create_joomla_user_account_when_registering',
					'type' 	=> 'radio',
					'std' 	=> '',
					'taxonomy' => '',
					'required' => 0,
					'class' => '',
					'values' => array('No','Yes'),
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => 'enable_registration_yes_no',
					'is_wp_editor' => 0 
				),
				array(
					'name' 	=> __( 'Select the Wordpress user group to add event registrants to', 'event-registration-pro' ), 
					'desc'	=> '',
					'id' 	=> $prefix . 'select_the_joomla_user_group_to_add_event_registrants_to',
					'type' 	=> 'select',
					'std' 	=> '',
					'taxonomy' => '',
					'required' => 0,
					'class' => '',
					'values' => array('Subscriber','Administrator','Author','Editor','Contributor'),
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => 'userclass_show enable_registration_yes_no',
					'is_wp_editor' => 0 
				)              
			)   
		);
		add_meta_box($meta_box_registration['id'], $meta_box_registration['title'], array(&$this, 'show_erp_event_registration_metabox'), 'erp_event', $meta_box_registration['context'], $meta_box_registration['priority']); 
	}
	 
	//Function to show Event Registration Metaboxes 
	public function show_erp_event_registration_metabox()  
	{    
		global $meta_box_registration;  
		$plugin_show_metabox = new Event_Registration_Pro_Show_Metabox();
        $plugin_show_metabox->fn_show_fields($meta_box_registration,'event_registration'); 
	} 
	 
	//4 .........................Emails Tab.................................................
	public function add_erp_event_emails_metabox()
	{ 	
		$prefix = 'erp_event_';
		global $meta_box_emails;
		

		$meta_box_emails = array(
			'id' => 'event-emails-meta-boxes',
			'title' => __( 'Emails', 'event-registration-pro' ),
			'page' => 'erp_event',  
			'context' => 'normal',
			'priority' => 'low',
			'fields' => array(
				
				array(
					'name' 	=> __( 'Event organizer notification emails', 'event-registration-pro' ), 
					'desc'	=> 'If you wish to have emails notified of registrations to this specific event you can add them here. Add multiple emails as comma separated, For example (admin1@website.com, admin2@website.com).',
					'id' 	=> $prefix . 'event_organizer_notification_emails',
					'type' 	=> 'text',
					'std' 	=> '',
					'taxonomy' => '',
					'required' => 0,
					'class' => '',
					'values' => '',
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => 'Email Notification Settings',
					'extra_class_div' => '',
					'is_wp_editor' => 0 
				),
				array(
					'name' 	=>  __( 'CC confirmation emails to', 'event-registration-pro' ), 
					'desc'	=> "A carbon copy of the registrant's confirmation email for this event will be sent to email addresses entered into this field.",
					'id' 	=> $prefix . 'cc_confirmation_emails_to',
					'type' 	=> 'text',
					'std' 	=> '',
					'taxonomy' => '',
					'required' => 0,
					'class' => '',
					'values' => '',
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => '',
					'is_wp_editor' => 0 
				),  
				array(
					'name' 	=>  __( 'Send reminder emails to registrants', 'event-registration-pro' ), 
					'desc'	=> '<div class="desc">days before the event start date. <br/>All registrants to this event will receive a reminder email X days before the start date of the event.<br>You can configure the email text by ckicking this Info Icon.</div>',
					'id' 	=> $prefix . 'send_reminder_emails_to_registrants',
					'type' 	=> 'text',
					'std' 	=> '',
					'taxonomy' => '',
					'required' => 0,
					'class' => '',
					'values' => '',
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => '',
					'is_wp_editor' => 0 
				),
				array(
					'name' 	=>  __( 'Registrant Confirmation', 'event-registration-pro' ), 
					'desc'	=> '',
					'id' 	=> $prefix . 'registrant_confirmation',
					'type' 	=> 'select',
					'std' 	=> '',
					'taxonomy' => 'registrant_confirmation_email',
					'required' => 0,
					'class' => '',
					'values' => '',
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => 'Email Templates To Use For This Event',
					'extra_class_div' => '',
					'is_wp_editor' => 0
				),
				array(
					'name' 	=> __( 'Organizer Confirmation', 'event-registration-pro' ), 
					'desc'	=> '',
					'id' 	=> $prefix . 'organizer_confirmation',
					'type' 	=> 'select',
					'std' 	=> '',
					'taxonomy' => 'organizer_confirmation_email',
					'required' => 0,
					'class' => '',
					'values' => '',
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => '',
					'is_wp_editor' => 0 
				),
				array(
					'name' 	=> __( 'Reminder Notification', 'event-registration-pro' ), 
					'desc'	=> '',
					'id' 	=> $prefix . 'reminder_notification',
					'type' 	=> 'select',
					'std' 	=> '',
					'taxonomy' => 'reminder_notification_email',
					'required' => 0,
					'class' => '',
					'values' => '',
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => '',
					'is_wp_editor' => 0 
				),
				array(
					'name' 	=> __( 'Invoice', 'event-registration-pro' ), 
					'desc'	=> '',
					'id' 	=> $prefix . 'invoice',
					'type' 	=> 'select',
					'std' 	=> '',
					'taxonomy' => 'invoice_email',
					'required' => 0,
					'class' => '',
					'values' => '',
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => '',
					'is_wp_editor' => 0 
				)               
			)   
		);
		add_meta_box($meta_box_emails['id'], $meta_box_emails['title'], array(&$this, 'show_erp_event_emails_metabox'), 'erp_event', $meta_box_emails['context'], $meta_box_emails['priority']); 
	}
	 
	//Function to show Event Emails Metaboxes 
	public function show_erp_event_emails_metabox()  
	{   
		global $meta_box_emails;  
		$plugin_show_metabox = new Event_Registration_Pro_Show_Metabox();
        $plugin_show_metabox->fn_show_fields($meta_box_emails,'event_emails'); 
	} 
	  
	//5 .........................Repeating Tab.................................................
	public function add_erp_event_repeating_metabox()
	{ 	
		$prefix = 'erp_event_';
		global $meta_box_repeating;
		$meta_box_repeating = array(
			'id' => 'event-repeating-meta-boxes',
			'title' => __( 'Repeating', 'event-registration-pro' ),
			'page' => 'erp_event',  
			'context' => 'normal',
			'priority' => 'low',
			'fields' => array(
				array(
					'name' 	=> __( 'Recurrence', 'event-registration-pro' ), 
					'desc'	=> '',
					'id' 	=> $prefix . 'recurrence',
					'type' 	=> 'select',
					'std' 	=> '',
					'taxonomy' => '',
					'required' => 0,
					'class' => '',
					'values' => array('nothing','daily','weekly','monthly','weekday','Dates'),
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => '',
					'is_wp_editor' => 0
				)              
			)   
		);
		add_meta_box($meta_box_repeating['id'], $meta_box_repeating['title'], array(&$this, 'show_erp_event_repeating_metabox'), 'erp_event', $meta_box_repeating['context'], $meta_box_repeating['priority']); 
	}
	 
	//Function to show Event Repeating Metaboxes 
	public function show_erp_event_repeating_metabox()  
	{   
		global $meta_box_repeating;  
		$plugin_show_metabox = new Event_Registration_Pro_Show_Metabox();
        $plugin_show_metabox->fn_show_fields($meta_box_repeating,'event_repeating'); 
	} 
	  
	//6 .........................Metadata.................................................
	public function add_erp_event_metadata_metabox()
	{ 	
		$prefix = 'erp_event_';
		global $meta_box_metadata;
		$meta_box_metadata = array(
			'id' => 'event-metadata-meta-boxes',
			'title' => __( 'Metadata', 'event-registration-pro' ),
			'page' => 'erp_event',  
			'context' => 'normal',
			'priority' => 'low',
			'fields' => array(
				array(
					'name' 	=> __( 'Metadata Description', 'event-registration-pro' ), 
					'desc'	=> '',
					'id' 	=> $prefix . 'metadata_description',
					'type' 	=> 'textarea',
					'std' 	=> '',
					'taxonomy' => '',
					'required' => 0,
					'class' => '',
					'values' => '',
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => '',
					'is_wp_editor' => 0 
				),
				array(
					'name' 	=> __( 'Metadata keywords', 'event-registration-pro' ), 
					'desc'	=> '',
					'id' 	=> $prefix . 'metadata_keywords',
					'type' 	=> 'textarea',
					'std' 	=> '',
					'taxonomy' => '',
					'required' => 0,
					'class' => '',
					'values' => '',
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => '',
					'is_wp_editor' => 0 
				),
				array(
					'name' 	=> __( 'Robots', 'event-registration-pro' ), 
					'desc'	=> '',
					'id' 	=> $prefix . 'robots',
					'type' 	=> 'text',
					'std' 	=> '',
					'taxonomy' => '',
					'required' => 0,
					'class' => '',
					'values' => '',
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => '',
					'is_wp_editor' => 0 
				)              
			)   
		);
		add_meta_box($meta_box_metadata['id'], $meta_box_metadata['title'], array(&$this, 'show_erp_event_metadata_metabox'), 'erp_event', $meta_box_metadata['context'], $meta_box_metadata['priority']); 
	}
	 
	//Function to show Event Metadata Metaboxes 
	public function show_erp_event_metadata_metabox()  
	{   
		global $meta_box_metadata; 
		$plugin_show_metabox = new Event_Registration_Pro_Show_Metabox();
        $plugin_show_metabox->fn_show_fields($meta_box_metadata,'event_metadata');  
	} 
	 
	//7 .........................Event Tickets.................................................
	public function add_erp_event_tickets_metabox()
	{ 	
		do_action('addon_show_ticket_section_event_registration_pro_ticket_standard');
	}
		
	
 	//8 .........................Event Thumbnail Image.................................................
	public function replace_featured_image_box()  
	{    
		remove_meta_box( 'postimagediv', 'erp_event', 'side' );
		add_meta_box('postimagediv', 'Event Thumbnail Image', 'post_thumbnail_meta_box', 'erp_event', 'side', 'low'); 
	}    
	 
	//9 .........................Event Excerpt Box.................................................
	/* -----------------------------------------
	 * Put excerpt meta-box before editor
	 * ----------------------------------------- */
	public function add_excerpt_meta_box() { 
		add_meta_box(
			// change to something other then normal, advanced or side
			'postexcerpt', __( 'Excerpt' ), 'post_excerpt_meta_box', 'erp_event', 'post_excerpt', 
			'high'
		); 
	}
	
	public function fn_move_deck() {
		# Get the globals:
		global $post, $wp_meta_boxes;

		# Output the "advanced" meta boxes:
		do_meta_boxes( get_current_screen(), 'post_excerpt', $post );

		# Remove the initial "advanced" meta boxes:
		unset($wp_meta_boxes['post']['post_excerpt']);
	} 
	
	//10 .........................Add Archive bulk action to Event.................................................
	public function register_event_archive_bulk_action($bulk_actions)  
	{     
		 $bulk_actions['erp_event_archive'] = __( 'Archive', 'erp_event_archive');
		 return $bulk_actions;
	}   
	
	/**
 	* Handles the bulk action.
	*/
	public function event_archive_bulk_action_handler( $redirect_to, $action, $post_ids ) {
		 
		if ( $action !== 'erp_event_archive' ) {
			return $redirect_to;
		}
	
		foreach ( $post_ids as $post_id ) {
			wp_update_post( array(
				'ID'          => $post_id,
				'post_status' => 'archive',
			) );
		}
		
		$redirect_to = add_query_arg( 'bulk_draft_posts', count( $post_ids ), $redirect_to );
	
		return $redirect_to;
	} 
	
	/**
	* Shows a notice in the admin once the bulk action is completed.
	*/
	function event_archive_bulk_action_admin_notice() {
		if ( ! empty( sanitize_text_field($_REQUEST['bulk_draft_posts']) ) ) {
			$drafts_count = intval( $_REQUEST['bulk_draft_posts'] );
		
			printf(
				'<div id="message" class="updated fade">' .
				_n( '%s post moved to archive.', '%s posts moved to archive.', $drafts_count, 'domain' )
				. '</div>',
				$drafts_count
			);
		}
	}  
	////////////////////////////////////////////////////////////////////////////////////////////// 
	
	
	///////////////////////////////////// Location Manager /////////////////////////////////////////////
	public function add_erp_location_manager_metabox()
	{   
		$prefix = 'erp_event_location_manager_';
		global $meta_box_location_manager;
		 
		$meta_box_location_manager = array(
			'id' => 'location-manager-meta-boxes',
			'title' => __( 'Location Details', 'event-registration-pro' ),
			'page' => 'erp_locations',  
			'context' => 'normal',
			'priority' => 'low',
			'fields' => array( 
				array(
					'name' 	=> __( 'Location URL', 'event-registration-pro' ), 
					'desc'	=> '<div class="desc">EXAMPLE: http://www.google.com!</div>',
					'id' 	=> $prefix . 'location_url',
					'type' 	=> 'text',
					'std' 	=> '',
					'taxonomy' => '',
					'required' => 0,
					'class' => '',
					'values' => '',
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => '',
					'is_wp_editor' => 0 
				), 
				array(
					'name' 	=> __( 'Street', 'event-registration-pro' ), 
					'desc'	=> '',
					'id' 	=> $prefix . 'street',
					'type' 	=> 'text',
					'std' 	=> '',
					'taxonomy' => '',
					'required' => 0,
					'class' => 'txt_street',
					'values' => '',
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => '',
					'is_wp_editor' => 0   
				), 
				array(
					'name' 	=> __( 'City/State', 'event-registration-pro' ), 
					'desc'  => '',
 					'id' 	=> $prefix . 'city_state',
					'type' 	=> 'text',
					'std' 	=> '',
					'taxonomy' => '',
					'required' => 1,
					'class' => 'txt_city half-width',
					'values' => '',
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => '',
					'is_wp_editor' => 0 
				),  
				array(
					'name' 	=> __( 'ZIP', 'event-registration-pro' ),
					'desc'	=> '',
					'id' 	=> $prefix . 'zip',
					'type' 	=> 'text',
					'std'	=> '',
					'taxonomy' => '',
					'required' => 0,
					'class' => 'half-width',
					'values' => '',
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => '',
					'is_wp_editor' => 0
				),
				array(
					'name' 	=> __( 'Phone', 'event-registration-pro' ),
					'desc'	=> '',
					'id' 	=> $prefix . 'phone',
					'type' 	=> 'text',
					'std'	=> '',
					'taxonomy' => '',
					'required' => 0,
					'class' => 'half-width',
					'values' => '',
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => '',
					'is_wp_editor' => 0
				),
				array(
					'name' 	=> __( 'Country (US,DE,AT,CH, etc.)', 'event-registration-pro' ),
					'desc'	=> '',
					'id' 	=> $prefix . 'country',
					'type' 	=> 'text',
					'std'	=> '',
					'taxonomy' => '',
					'required' => 0,
					'class' => 'txt_country half-width',
					'values' => '',
					'post_type' => '',
					'maxlength' => '3',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => '',
					'is_wp_editor' => 0 
				),
				
				array(
					'name' 	=> '',
					'desc'	=> '',
					'id' 	=> '',
					'type' 	=> 'map',
					'std'	=> '',
					'taxonomy' => '',
					'required' => 0,
					'class' => '',
					'values' => '<div id="map-canvas"></div>',
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => '',
					'is_wp_editor' => 0 
				)              
			)   
		); 
		add_meta_box($meta_box_location_manager['id'], $meta_box_location_manager['title'], array(&$this, 'show_erp_location_manager_metabox'), 'erp_locations', $meta_box_location_manager['context'], $meta_box_location_manager['priority']);   
	}
	
	//Function to show Event Location Manager Metaboxes 
	public function show_erp_location_manager_metabox()  
	{   
		global $meta_box_location_manager;  
		$plugin_show_metabox = new Event_Registration_Pro_Show_Metabox();
        $plugin_show_metabox->fn_show_fields($meta_box_location_manager,'location_manager');  
	}   
	////////////////////////////////////////////////////////////////////////////////////////////// 
	
	
	///////////////////////////////////// Organizers /////////////////////////////////////////////
	public function add_erp_organizers_metabox()
	{   
		$prefix = 'erp_event_organizer_';
		global $meta_box_organizers;
		 
		$meta_box_organizers = array(
			'id' => 'organizers-meta-boxes',
			'title' =>  __( 'Organizers Details', 'event-registration-pro' ),
			'page' => 'erp_organizers',  
			'context' => 'normal',
			'priority' => 'low',
			'fields' => array( 
				array(
					'name' 	=>  __( 'Organizer Phone', 'event-registration-pro' ), 
					'desc'	=> '',
					'id' 	=> $prefix . 'phone',
					'type' 	=> 'text',
					'std' 	=> '',
					'taxonomy' => '',
					'required' => 0,
					'class' => '',
					'values' => '',
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => '',
					'is_wp_editor' => 0 
				), 
				array(
					'name' 	=>  __( 'Organizer Email', 'event-registration-pro' ), 
					'desc'	=> '',
					'id' 	=> $prefix . 'email',
					'type' 	=> 'text',
					'std' 	=> '',
					'taxonomy' => '',
					'required' => 0,
					'class' => '',
					'values' => '',
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => '',
					'is_wp_editor' => 0    
				), 
				array(
					'name' 	=>  __( 'Organizer Website', 'event-registration-pro' ), 
					'desc'  => '<div class="desc">EXAMPLE: http://eventregistrationpro.com!</div>',
 					'id' 	=> $prefix . 'website',
					'type' 	=> 'text',
					'std' 	=> '',
					'taxonomy' => '',
					'required' => 0,
					'class' => '',
					'values' => '',
					'post_type' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => '',
					'is_wp_editor' => 0  
				),  
				array(
					'name' 	=>  __( 'Organizer Photo', 'event-registration-pro' ),
					'desc'	=> '',
					'id' 	=> $prefix . 'photo',
					'type' 	=> 'image',
					'std'	=> '',
					'taxonomy' => '',
					'required' => 0,
					'class' => '',
					'values' => '',
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => '',
					'is_wp_editor' => 0 
				)               
			)   
		);
		add_meta_box($meta_box_organizers['id'], $meta_box_organizers['title'], array(&$this, 'show_erp_organizers_metabox'), 'erp_organizers', $meta_box_organizers['context'], $meta_box_organizers['priority']);   
	}
	
	//Function to show Event Organizers Metaboxes 
	public function show_erp_organizers_metabox()  
	{   
		global $meta_box_organizers;  
		$plugin_show_metabox = new Event_Registration_Pro_Show_Metabox();
        $plugin_show_metabox->fn_show_fields($meta_box_organizers,'organizers_details');  
	}   
	////////////////////////////////////////////////////////////////////////////////////////////// 

	 
	///////////////////add extra fields to category edit form callback function//////////////////// 
	public function add_erp_extra_category_fields( $tag ) 
	{    
	 	$prefix = 'erp_event_category_';
		global $meta_box_category;
		 
		$meta_box_category = array(
			'id' => 'category-meta-boxes',
			'title' =>  __( 'Category Details', 'event-registration-pro' ),
			'page' => 'erp_category',  
			'context' => 'normal',
			'priority' => 'low',
			'fields' => array( 
				
				array(
					'name' 	=>  __( 'Background Color', 'event-registration-pro' ),
					'desc'	=> '',
					'id' 	=> $prefix . 'background_color',
					'type' 	=> 'text',
					'std'	=> '',
					'taxonomy' => '',
					'required' => 0,
					'class' => 'jscolor {width:101, padding:0, shadow:false,borderWidth:0, backgroundColor:"transparent", insetColor:"#000"}',
					'values' => '',
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => '',
					'is_wp_editor' => 0 
				),
				array(
					'name' 	=>  __( 'Text Color', 'event-registration-pro' ),
					'desc'	=> '',
					'id' 	=> $prefix . 'text_color',
					'type' 	=> 'text',
					'std'	=> '',
					'taxonomy' => '',
					'required' => 0,
					'class' => 'jscolor {width:101, padding:0, shadow:false,borderWidth:0, backgroundColor:"transparent", insetColor:"#000"}',
					'values' => '',
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => '',
					'is_wp_editor' => 0 
				), 
				array(
					'name' 	=>  __( 'Category Image', 'event-registration-pro' ), 
					'desc'	=> '',
					'id' 	=> $prefix . 'image_url',
					'type' 	=> 'image',
					'std' 	=> '',
					'taxonomy' => '',
					'required' => 0,
					'class' => '',
					'values' => '',
					'post_type' => 'category_image',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => '',
					'is_wp_editor' => 0 
				),
				array(
					'name' 	=> '', 
					'desc'	=> '',
					'id' 	=> $prefix . 'all_fields',
					'type' 	=> 'hidden',
					'std' 	=> '',
					'taxonomy' => '',
					'required' => 0,
					'class' => '',
					'values' => 'category,publish,background_color,text_color,access,image_url',
					'post_type' => 'category',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => '',
					'is_wp_editor' => 0 
				)               
			)   
		);
		
		$plugin_show_metabox = new Event_Registration_Pro_Show_Metabox();
        $plugin_show_metabox->fn_show_fields($meta_box_category,'category_details');  
	} 
	///////////////////////////////////////////////////////////////////////////////////////////////
	 
	///////////////////////////////////// Registration Forms ////////////////////////////////////// 
	//......................... 1 Tags ............................
	public function add_erp_regform_html_metabox()
	{
		$prefix = 'erp_event_regfrom_html_';
		global $meta_box_regform_html;
		   
		$meta_box_regform_html = array(
			'id' => 'regform-html-meta-boxes',
			'title' => __( 'Tags', 'event-registration-pro' ),
			'page' => 'erp_regforms',  
			'context' => 'side',			
			'priority' => 'low',
			'fields' => array( 
				array(
					'name' 	=> '', 
					'desc'	=> "",
					'id' 	=> $prefix . 'tags',
					'type' 	=> 'html',
					
					'std' 	=> '',
					'taxonomy' => '',
					'required' => 0,
					'class' => '',
					'values' => "The tags will be replaced with their value.<br/>
								{fullname} - The Registrant's Full Name <br/>
								{email} - The Registrant's Email address <br/>
								{sitename} - The website name defined in your global configuration <br/>
								{eventtitle} - The event title <br/>
								{location} - The Event Location <br/>
								{url} - The Event Homepage <br/>
								{city} - The Location City <br/> 
								{zip} - The Location Zip Code <br/>
								{street} - The Location Street Name <br/>
								{country} - The Location Country Code <br/>
								{locdescription} - The Location Description <br/>
								{eventstatus} - The event status <br/>
								{eventstart} - The event start date and time  <br/>
								{eventend} - The event end date and time <br/>
								{shortdesc} - The event short description <br/>
								{longdesc} - The event long description",
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => '',
					'is_wp_editor' => 0 
				),
			)	
		);	  
		add_meta_box($meta_box_regform_html['id'], $meta_box_regform_html['title'], array(&$this, 'show_erp_regform_html_metabox'), 'erp_regforms', $meta_box_regform_html['context'], $meta_box_regform_html['priority']);  
	}
	
	//Function to show Event Registration Form Tags Metaboxes 
	public function show_erp_regform_html_metabox()  
	{   
		global $meta_box_regform_html;  
		
		$plugin_show_metabox = new Event_Registration_Pro_Show_Metabox();
        $plugin_show_metabox->fn_show_fields($meta_box_regform_html,'registration_details');  
	}  
	
	//......................... 2 Form Fields ............................
	public function add_erp_regform_fields_metabox()
	{ 
		$prefix = 'regform_fields_';  
		global $meta_box_regform_fields, $post , $wpdb;
		 
		
		 $lastrowId=$wpdb->get_col( "SELECT ID FROM ".$wpdb->posts." where post_type='erp_regforms' ORDER BY post_date DESC " );

	 $lastPropertyId=$lastrowId[0];
		
	
		 $postid = 0; 
		$get_count = 0;
		
			if(empty($_REQUEST['post'])){			
				$function_post='onclick="return publish_post();"';
			}else{
				$function_post='';
			}
			
		if(isset($_REQUEST['post'])){
			$postid = trim(wp_filter_nohtml_kses($_REQUEST['post']));
			$get_count = get_post_meta($postid,'regform_fields_hid_count_meta_fields',true);
		} 
		else if(isset($_REQUEST['post_ID'])){
			$postid = trim(wp_filter_nohtml_kses($_REQUEST['post_ID']));
			
			$get_count = get_post_meta($postid,'regform_fields_hid_count_meta_fields',true);
		
		}
		if(isset($_REQUEST['customid']) && sanitize_text_field($_REQUEST['customid']) > 0){
			$count = 0;
			$new_count = 0;	
			$add_count = trim(wp_filter_nohtml_kses($_REQUEST['customid']));
			$cond = "'edit'";
			$hid_array = array(
					'name' 	=> '', 
					'desc'	=> '',
					'id' 	=> 'customid',
					'type' 	=> 'hidden',
					'std' 	=> '',
					'taxonomy' => '',
					'required' => 0,
					'class' => '',
					'values' => $add_count,
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => 'hide',
					'is_wp_editor' => 0 
				);
		}
		else { 
			$cond = "'add'";
			if($get_count!=''){ 
				$arr = explode(',',$get_count);
					
					$arr_count='1,2,3';
					if($get_count < $arr_count)	
					{	$get_count = $arr_count;
						$arr = explode(',',$get_count);
						
					}
					
				$count = max($arr);
				if($count > 0){ 
					$add_count = $count + 1;
					$new_count = $get_count.','.$add_count;
				}
				else
				{
					$count = 3;
					$new_count = '1,2,3';	
					$add_count = $count + 1;
				}
			}
			else
			{
				$count = 3;
				$new_count = '1,2,3,4';	
				$add_count = $count + 1;
			} 
			
			$hid_array = array();
		}
		 
		$meta_box_regform_fields =  array(
			'id' => 'regform-fields-meta-boxes',
			'title' => __( 'Form Fields', 'event-registration-pro' ),
			'page' => 'erp_regform_fields',  
			'context' => 'normal',
			'priority' => 'low',
			'fields' => array( 
				$hid_array,
				
				array(
					'name' 	=> __( 'Field Identification', 'event-registration-pro' ), 
					'desc'	=> 'Has to be unique for each form.',
					'id' 	=> $prefix . 'field_identification_'.$add_count,
					'type' 	=> 'text',
					'std' 	=> '',
					'taxonomy' => '',
					'required' => 1,
					'class' => $prefix . 'field_identification',
					'values' => '',
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 1,
					'sub_title_div' => '',
					'extra_class_div' => '',
					'is_wp_editor' => 0 
				),
				array(
					'name' 	=> __( 'Field Title', 'event-registration-pro' ), 
					'desc'	=> 'This will tell the registrant what data to insert.',
					'id' 	=> $prefix . 'field_title_'.$add_count,
					'type' 	=> 'text',
					'std' 	=> '',
					'taxonomy' => '',
					'required' => 1,
					'class' => $prefix . 'field_title',
					'values' => '',
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 1,
					'sub_title_div' => '',
					'extra_class_div' => '',
					'is_wp_editor' => 0 
				),
				array(
					'name' 	=> '', 
					'desc'	=> '',
					'id' 	=> $prefix . 'hid_count_meta_fields',
					'type' 	=> 'hidden',
					'std' 	=> '',
					'taxonomy' => '',
					'required' => 0,
					'class' => '',
					'values' => $new_count,
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => 'hide',
					'is_wp_editor' => 0 
				),
				array(
					'name' 	=> '', 
					'desc'	=> '',
					'id' 	=> $prefix . 'hid_current_count_meta_fields',
					'type' 	=> 'hidden',
					'std' 	=> '',
					'taxonomy' => '',
					'required' => 0,
					'class' => $prefix . 'hid_current_count_meta_fields',
					'values' => $add_count,
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => 'hide',
					'is_wp_editor' => 0 
				),
				array(
					'name' 	=> '', 
					'desc'	=> '',
					'id' 	=> $prefix . 'hid_meta_fields',
					'type' 	=> 'hidden',
					'std' 	=> '',
					'taxonomy' => '',
					'required' => 0,
					'class' => '',
					'values' => 'regform_fields_field_identification,regform_fields_field_title,regform_fields_field_description,regform_fields_field_type,regform_fields_conditional_field,regform_fields_validation_rule,regform_fields_default_field_value,regform_fields_additional_attributes',
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => 'hide',
					'is_wp_editor' => 0 
				),
				array(
					'name' 	=> __( 'Field Description(optional)', 'event-registration-pro' ), 
					'desc'	=> 'This will be published near the field for more information.',
					'id' 	=> $prefix . 'field_description_'.$add_count,
					'type' 	=> 'textarea',
					'std' 	=> '',
					'taxonomy' => '',
					'required' => 0,
					'class' => $prefix . 'field_description',
					'values' => '',
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => '',
					'is_wp_editor' => 0 
				),
				array(
					'name' 	=> __( 'Field Type', 'event-registration-pro' ), 
					'desc'	=> 'The type of the field',
					'id' 	=> $prefix . 'field_type_'.$add_count,
					'type' 	=> 'select',
					'std' 	=> '',
					'taxonomy' => '',
					'required' => 0,
					'class' => $prefix . 'field_type',
					'values' => array('text','email','password','textarea','select','multiselect','radio','checkbox','multicheckbox','file','calendar','country','state','groups'),
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 1,
					'sub_title_div' => '',
					'extra_class_div' => '',
					'is_wp_editor' => 0 
				),  
				 
				array(
					'name' 	=> __( 'Validation Rule', 'event-registration-pro' ), 
					'desc'	=> 'Choose one of the validation rules for this field.',
					'id' 	=> $prefix . 'validation_rule_'.$add_count,
					'type' 	=> 'select',
					'std' 	=> '',
					'taxonomy' => '',
					'required' => 0,
					'class' => $prefix . 'validation_rule',
					'values' => array('Please select','confirm','email','number','mandatory'),
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 1,
					'sub_title_div' => '',
					'extra_class_div' => '',
					'is_wp_editor' => 0 
				),   
				array(
					'name' 	=> __( 'Default Field Value', 'event-registration-pro' ), 
					'desc'	=> 'The default value for calender field must be in (YYYY-MM-DD) format.',
					'id' 	=> $prefix . 'default_field_value_'.$add_count,
					'type' 	=> 'text',
					'std' 	=> '',
					'taxonomy' => '',
					'required' => 0,
					'class' => $prefix . 'default_field_value',
					'values' => '',
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 1,
					'sub_title_div' => '',
					'extra_class_div' => '',
					'is_wp_editor' => 0 
				),
				array(
					'name' 	=> __( 'Additional Attributes', 'event-registration-pro' ), 
					'desc'	=> 'This allows you to add custom attributes at the end of the field tag. You could add style = "width:100%;" for example.',
					'id' 	=> $prefix . 'additional_attributes_'.$add_count,
					'type' 	=> 'text',
					'std' 	=> '',
					'taxonomy' => '',
					'required' => 0,
					'class' => $prefix . 'additional_attributes',
					'values' => '',
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 1,
					'sub_title_div' => '',
					'extra_class_div' => '',
					'is_wp_editor' => 0 
				),
				array(
					'name' 	=> '', 
					'desc'	=> '',
					'id' 	=> $prefix . 'html',
					'type' 	=> 'html',
					'std' 	=> '',
					'taxonomy' => '',
					'required' => 0,
					'class' => 'left',
					'values' => '<input type="submit" name="reg_form_meta_field" id="submit_meta" '.$function_post.'  value="Save" class="button button-primary button-large" /> <a href="javascript:void(0);" id="regform_fields_cancel" class="left" onclick="return fn_cancel_regform_edit('.$cond.','.$postid.');">Cancel</a>',
					'post_type' => '',
					'maxlength' => '',
					'half_width' => 0,
					'sub_title_div' => '',
					'extra_class_div' => 'left',
					'is_wp_editor' => 0 
				)
				
			)
		);		  
		
		//if post is not saved then do not show form fields metabox
		$post_title = get_the_title($postid);
		if($post_title!=''){
			add_meta_box($meta_box_regform_fields['id'], $meta_box_regform_fields['title'], array(&$this, 'show_erp_regform_fields_metabox'), 'erp_regforms', $meta_box_regform_fields['context'], $meta_box_regform_fields['priority']); 
			      
		}
	}
	
	//Function to show Event Registration Form Fields Metaboxes 
	public function show_erp_regform_fields_metabox()  
	{    
		 
		global $meta_box_regform_fields, $post; 
		$nonce = wp_create_nonce( 'erp-nonce' );
		 $postid = $post->ID;  
		
		
		        add_post_meta( $postid, 'regform_fields_field_title_1', 'First Name', true );
				add_post_meta( $postid, 'regform_fields_field_identification_1', 'firstname', true );
				add_post_meta( $postid, 'regform_fields_field_type_1', 'text', true );
				add_post_meta( $postid, 'regform_fields_field_ordering_1', '1', true );
				add_post_meta( $postid, 'regform_fields_validation_rule_1', 'mandatory', true );
				add_post_meta( $postid, 'regform_fields_field_title_2', 'Last Name', true );
				add_post_meta( $postid, 'regform_fields_field_identification_2', 'lastname', true );
				add_post_meta( $postid, 'regform_fields_field_type_2', 'text', true );
				add_post_meta( $postid, 'regform_fields_field_ordering_2', '2', true );
				add_post_meta( $postid, 'regform_fields_validation_rule_2', 'mandatory', true );
				add_post_meta( $postid, 'regform_fields_field_title_3', 'Email', true );
				add_post_meta( $postid, 'regform_fields_field_identification_3', 'email', true );
				add_post_meta( $postid, 'regform_fields_field_type_3', 'email', true );
				add_post_meta( $postid, 'regform_fields_field_ordering_3', '3', true );
				add_post_meta( $postid, 'regform_fields_validation_rule_3', 'mandatory', true );
				add_post_meta( $postid, 'initial_field_count', '1,2,3', true );
				add_post_meta( $postid, 'regform_fields_hid_count_meta_fields', '1,2,3', true );
				add_post_meta( $postid, 'regform_fields_hid_current_count_meta_fields', '3', true );
		 			
		if(isset($_GET['customid']) && sanitize_text_field($_GET['customid']) > 0){
			$reg_form_fields_style = '';
			$div_add_more_fields_style = 'style="display:none;"'; 
			
  		} 
		else
		{
			$reg_form_fields_style = 'style="display:none;"';
			$div_add_more_fields_style = '';
			
		}
		
		?>
		<div class="div-add-more-fields" <?php echo $div_add_more_fields_style;?> ><a href="javascript:void(0);" onclick="return show_regform_fields();" class="add-more-fields">Add more form fields</a> <a href="javascript:void(0);" class="delete-fields" onclick="return regform_delete(<?php echo $postid;?>,'<?php echo $nonce;?>');">Delete</a></div>
		
		<?php
		              
		 
		echo '<div id="reg_form_fields" '.$reg_form_fields_style.'   >';		
			$plugin_show_metabox = new Event_Registration_Pro_Show_Metabox();
        	$plugin_show_metabox->fn_show_fields($meta_box_regform_fields,'regform_fields_details');   
		echo '</div>'; 
		
		$imgpath =  esc_url(plugin_dir_url( dirname( __FILE__ ) ) . 'admin/css/images/filesave.png');  
		
		if(isset($_GET['rforder'])){
			$rforder = trim(sanitize_text_field($_GET['rforder'])); 
			if($rforder=='asc')
			{
				$order = 'desc';
				$class = "sorted asc";	
			}
			else if($rforder=='desc')
			{
				$order = 'asc';
				$class = "sorted desc";	
			}
		} 
		else
		{
			$order = 'asc';	
			$class = "sorted desc";	
		}
		
					
				
		
		 $get_fields = get_post_meta($postid,'regform_fields_hid_meta_fields',true);
				
				 $get_fields_count = get_post_meta($postid,'regform_fields_hid_count_meta_fields',true);
				 $initial_field_count = get_post_meta($postid,'initial_field_count',true);
				
					 $module_layout = explode(",",$get_fields_count);
				 
	?>
    	<table class="wp-list-table widefat fixed striped posts regform_list_table">
        	<thead>
        	<thead>
        	<tr>
            	<th class="th_head"><input type="checkbox" name="all" id="th_head" class="all_th_head" onclick="return chkAll('all_th_head','th_head_sub');" /></th>
            	<th>Field Title</th>
                <th>Field Identification</th>
                <th>Field Type</th>
                <th class="column-order <?php echo $class; ?>"><a href="javascript:void(0);" onclick="return save_order_regform_fields(<?php echo $postid;?>,'<?php echo $nonce ;?>','<?php echo $order; ?>');"><img title="Save" alt="Save" src="<?php echo $imgpath; ?>" /> Order</a> <span class="sorting-indicator"></span></th>
                <th>ID</th> 
            </tr>
            </thead>
            <tbody id="the-list">
            
            <?php  
				  
				
						
				foreach($module_layout as $key => $val){
							  if (empty($val)) unset($module_layout[$key]);
							}
							     
				foreach($module_layout as $layout){ 
					$arr_field_ordering[get_post_meta($postid,'regform_fields_field_ordering_'.$layout,true)] = $layout; 
				}
				
				//sort array 
				if($order=='asc'){ 
					sort($arr_field_ordering);
				}
				else
				{
					rsort($arr_field_ordering);
				} 
				$i = 0;
				
					
					$arr_field_ordering=array();
					
					  
					
					foreach($module_layout as $layout){ 
					
						$field_ordering = get_post_meta($postid,'regform_fields_field_ordering_'.$layout,true);
				  
						$arr_field_ordering[$layout] = $field_ordering;
						
					}	
						
					 asort($arr_field_ordering);
					
						

				   
				   
					foreach($arr_field_ordering as $layout=>$val){ 
					
						$field_title = get_post_meta($postid,'regform_fields_field_title_'.$layout,true);
						
						
							$field_identification = get_post_meta($postid,'regform_fields_field_identification_'.$layout,true);
							$field_type = get_post_meta($postid,'regform_fields_field_type_'.$layout,true);
							$field_ordering = get_post_meta($postid,'regform_fields_field_ordering_'.$layout,true);
							if(empty($field_ordering) AND empty($field_title)){ 
								add_post_meta( $postid, 'regform_fields_field_ordering_'.$layout, $layout, true );
							}
							$field_id = $layout; 
							
            ?>	
                <tr><?php if($field_identification == 'firstname' OR $field_identification == 'lastname' OR $field_identification == 'email'){ echo '<td></td>';}else {?>
                	<td><input type="checkbox" class="regform_fields th_head_sub"  value="<?php echo $field_id; ?>" name="regform_fields[]" onclick="return subchkAll('regform_fields[]','all_th_head',this);" /></td>
                    <?php  } ?>
            		<td><a href="javascript:void(0);" onclick="return fn_edit_regform(<?php echo $field_id.','.$postid; ?>);"><?php echo $field_title; ?></a></td>
                    <td><?php echo $field_identification; ?></td>
                    <td><?php echo $field_type; ?></td>
                    <td><input type="text" name="postorder[]" id="<?php echo $field_id; ?>" class="postorder" value="<?php echo ($field_ordering)?$field_ordering:$field_id; ?>" /></td>
                    <td><?php echo $field_id; ?></td>     	
                </tr> 
                
            <?php 	//$i++; 
			    } 
				
			?>
            </tbody>
        </table>   
    <?php   
	}  
	///////////////////////////////////////////////////////////////////////////////////////////////
	  
	/////////////////////////////////////////////Save POST Data////////////////////////////////////
	public function save_custom_meta($post_id) { 
		global $meta_box_details, $meta_box_access, $meta_box_registration, $meta_box_organizers, $meta_box_metadata, $meta_box_location_manager,  $meta_box_regform_fields,$meta_box_email_template,$meta_box_emails,$meta_box_tickets;  		 
		
		
		
		if(isset($_POST['event_meta_box_nonce']))
		{ 
	
			if(isset($_POST['ticket_form_meta_field']) && sanitize_text_field($_POST['ticket_form_meta_field'])=='Save'){
				$global_array = array($meta_box_details, $meta_box_access, $meta_box_registration,$meta_box_metadata,$meta_box_emails,$meta_box_tickets); 
			}else{
				
				$global_array = array($meta_box_details, $meta_box_access, $meta_box_registration,$meta_box_metadata,$meta_box_emails);
			}
			
			
				
		}
		
		else if(isset($_POST['organizers_meta_box_nonce']))
		{
			$global_array = array($meta_box_organizers); 
			
		}
		else if(isset($_POST['location_manager_meta_box_nonce']))
		{
			$global_array = array($meta_box_location_manager); 
			
		} 
		else if(isset($_POST['regform_fields_meta_box_nonce']))
		
		{      
				
			$global_array = array($meta_box_regform_fields); 
			
			
		}
		else if(isset($_POST['emailtemplates_fields_meta_box_nonce']))
		{ 
			$global_array = array($meta_box_email_template); 
			
		} 
		
		
			


		
		if(isset($_POST['event_meta_box_nonce']) || isset($_POST['organizers_meta_box_nonce']) || isset($_POST['location_manager_meta_box_nonce']) || isset($_POST['regform_fields_meta_box_nonce']) || isset($_POST['emailtemplates_fields_meta_box_nonce']) || isset($_POST['event_tickets_meta_box_nonce']))
		{        
			foreach ($global_array as $key => $value) {
				if (empty($value)) {
				   unset($global_array[$key]);
				}
			}
			
			if(!empty($global_array)){
				
			// check permissions
			if ('page' == sanitize_text_field($_POST['post_type'])) {
				if (!current_user_can('edit_page', $post_id))
				return $post_id;
			} elseif (!current_user_can('edit_post', $post_id)) {
				return $post_id;
			}     
			  
			
			
			
			
			if(isset($_POST['regform_fields_meta_box_nonce']))
			{ 
				
				if(isset($_POST['reg_form_meta_field']) && sanitize_text_field($_POST['reg_form_meta_field'])=='Save')
				{
					 $m_count = count($global_array);
				}
				else
				{
					$m_count = 0;				
				}
			} 
			else
			{
				$m_count = count($global_array);
			} 
			 
			 
			if($m_count > 0){ 
			  
					foreach($global_array as $metabox){ 
						
					foreach($metabox['fields'] as $field) {
							
						 $text_val=wp_filter_post_kses($_POST[$field['id']]);
						 
						
					  	 $old = get_post_meta($post_id, $field['id'], true);						 
						 $new = wp_filter_post_kses($text_val);
						 if($new==''){	
						 
								if($field['required']==1 ) { 
									 
									
									$msg  = "Error: You must fill in ".wp_filter_post_kses(str_replace("*","",$field['name']))."<p><a href='post.php?post=".$post_id."&action=edit'>Back</a></p>";
									wp_die($msg, 'Error',  array( 'response' => 500 ));
									
									
								}else{
								update_post_meta($post_id, $field['id'], $new);
								}
							}
						else
						{ 
							
						
							if ($new && $new != $old) {
								
								$fieldttt=wp_filter_post_kses($_POST['regform_fields_hid_current_count_meta_fields']);
								
								if($field['id']=='regform_fields_field_identification_'.$fieldttt){
																	
									$new = str_replace(' ', '_', wp_filter_post_kses($_POST[$field['id']]));								 
								}
								
								update_post_meta($post_id, $field['id'], $new);
								
							} elseif ('' == $new && $old) {
								delete_post_meta($post_id, $field['id'], $old);
							}  
							/*if(isset($_POST['upload_image_'.$field['id']]) && santize_text_field($_POST['upload_image_'.$field['id']]) > 0){
								update_post_meta($post_id, 'upload_image_'.$field['id'], santize_text_field($_POST['upload_image_'.$field['id']]));
							} */
						}
					
					} // end foreach
					
					
					
					
				} // end foreach
			
			}
			//die;
			}
		}
	} 
	///////////////////////////////////////////////////////////////////////////////////////////////  
	
	////////////////////////////////////////Archive Manager////////////////////////////////////////////
	public function add_archive_page()
	{
		$plugin_archive = new Event_Registration_Pro_Archive(); 		
		$menu_slug = 'edit.php?post_type=erp_event';  
	 	add_submenu_page( $menu_slug, __( 'Archive Manager','event-registration-pro' ),__( 'Archive Manager','event-registration-pro' ) , 'manage_options', 'event-archive', array(&$plugin_archive, 'event_archive'));
	 	
	}     
	//////////////////////////////////////End Archive Manager/////////////////////////////////////////////
	
	
	/////////////////////////////////////////////Save Post Order///////////////////////////////////
	public function fn_saveorder()
	{	
		if(isset($_POST['erp_post']) && $_POST['erp_post']==1)
		{ 	
			
			
			foreach($_POST['erp_post'] as $key=>$val){	
					
				$index = $key;	
				$id = $val;
				$save_val_index = $_POST['val'][$index];
				$post = array(
					'ID'           => $id,
					'menu_order'   => $save_val_index 
				);
				
				// Update the post into the database
				wp_update_post( $post ); 
			}
		}	
	}
	///////////////////////////////////////////////////////////////////////////////////////////////
	
	/////////////////////////////////////////////Save Category Data////////////////////////////////
	public function save_erp_event_categories_metabox($term_id)
	{
		global $meta_box_category;   
		
		if(isset($_POST['taxonomy']) && sanitize_text_field($_POST['taxonomy'])=='erp-event-category')
		{  
			$erp_event_category_all_fields = explode(",",sanitize_text_field($_POST['erp_event_category_all_fields']));
			
			// loop through fields and save the data 
			foreach($erp_event_category_all_fields as $keys){
				if(isset($_POST['erp_event_category_'.$keys]) || isset($_POST['upload_image_erp_event_category_'.$keys])) { 
					
					$field = 'erp_event_category_'.$keys;
					$new = trim(strip_tags(sanitize_text_field($_POST[$field]))); 
					 
					$cat_meta[$field] = $new;
					if(isset($_POST['upload_image_'.$field]) && sanitize_text_field($_POST['upload_image_'.$field]) > 0){
						$cat_meta['upload_image_'.$field] = sanitize_text_field($_POST['upload_image_'.$field]); 
					}
				}
			}
			
			//save the option array
			update_option( "erp_event_category_".$term_id, $cat_meta);   
		} 
	} 
	///////////////////////////////////////////////////////////////////////////////////////////////
	
	
	//////////////////////Get registration form fields values when edit field////////////////////// 
	public function fn_get_regform_values()
	{ 	 
		if(isset($_POST['get_erp_regform_fields']) && sanitize_text_field($_POST['get_erp_regform_fields'])==1)
		{
			$postid = trim(strip_tags(sanitize_text_field($_POST['postid'])));
			$id = trim(strip_tags(sanitize_text_field($_POST['id'])));
			
			$field_title = get_post_meta($postid,'regform_fields_field_title_'.$id,true);
			$field_identification = get_post_meta($postid,'regform_fields_field_identification_'.$id,true);
			$field_type = get_post_meta($postid,'regform_fields_field_type_'.$id,true);
			$field_ordering = get_post_meta($postid,'regform_fields_field_ordering_'.$id,true); 
			$conditional_field = get_post_meta($postid,'regform_fields_conditional_field_'.$id,true);
			$field_validation_rule = get_post_meta($postid,'regform_fields_validation_rule_'.$id,true);
			$field_default_value = get_post_meta($postid,'regform_fields_default_field_value_'.$id,true);
			$field_additional_attributes = get_post_meta($postid,'regform_fields_additional_attributes_'.$id,true);
			$field_regform_fields_description = get_post_meta($postid,'regform_fields_field_description_'.$id,true);
			
			$array = array($field_title,$field_identification,$field_type,$conditional_field,$field_validation_rule,$field_default_value,$field_additional_attributes,$field_regform_fields_description); 
			echo json_encode($array);exit;
		}
	}
	///////////////////////////////////////////////////////////////////////////////////////////////
	
	//////////////////////Delete registration form fields////////////////////// 
	public function fn_deleteRegFormFields()
	{ 
		do_action('addon_delete_ticket_field_event_registration_pro_ticket_standard');
		
		if(isset($_POST['delRegFormFields']) && sanitize_text_field($_POST['delRegFormFields'])==1)
		{
			$postid = trim(strip_tags(sanitize_text_field($_POST['postid']))); 
			
			foreach($_POST['val'] as $key=>$val)
			{  
				$val=sanitize_text_field($val);
				delete_post_meta($postid,'regform_fields_field_title_'.$val);
				delete_post_meta($postid,'regform_fields_field_identification_'.$val);
				delete_post_meta($postid,'regform_fields_field_type_'.$val);
				delete_post_meta($postid,'regform_fields_field_ordering_'.$val);
				delete_post_meta($postid,'regform_fields_conditional_field_'.$val);
				delete_post_meta($postid,'regform_fields_validation_rule_'.$val);
				delete_post_meta($postid,'regform_fields_additional_attributes_'.$val);
				delete_post_meta($postid,'regform_fields_default_field_value_'.$val); 
				
				//update fields count
				$get_fields_count = get_post_meta($postid,'regform_fields_hid_count_meta_fields',true); 
				$arr_replace = array(",".$val,$val);  
				$str = str_replace($arr_replace,"",$get_fields_count);
				update_post_meta($postid,'regform_fields_hid_count_meta_fields',$str);
			}  
		}	
	}
	///////////////////////////////////////////////////////////////////////////////////////////////
	
	/////////////////////////////////////////////Save Registration form fields Order///////////////////////////////////
	public function fn_save_regFormFields_order()
	{
		 
		do_action('addon_sortorder_ticket_field_event_registration_pro_ticket_standard');
		
		if(isset($_POST['erp_regform_post']) && sanitize_text_field($_POST['erp_regform_post'])==1)
		{
			$postid = trim(strip_tags(sanitize_text_field($_POST['postid'])));
			
			
			foreach($_POST['id'] as $key=>$val){	
					
				$index = $key;	
				$id = $val;
				$order = sanitize_text_field($_POST['val'][$index]); 
			
				update_post_meta($postid,'regform_fields_field_ordering_'.$id,$order); 
			}
		}	
		
	} 
	
	
	
}